;pseudo opcodes
macro jsr_indirect(label)
	pea.w (+)-1
	jmp (<label>)
	+
endmacro

;mmio opcodes
macro write_twice(source, destination)
	lda <source>
	sta <destination>
	lda <source>+1
	sta <destination>
endmacro

;Game engine modes
macro set_game_prepare(mode)
	lda #<mode>
	sta game_prepare
endmacro

macro set_game_mode(mode)
	lda #<mode>
	sta game_mode
endmacro

macro set_nmi_prepare(mode)
	lda #<mode>
	sta nmi_prepare
endmacro

macro set_nmi_mode(mode)
	lda #<mode>
	sta nmi_mode
endmacro

macro set_irq_mode(mode)
	lda #<mode>
	sta irq_mode
endmacro


;This should only be used in fblank, to do DMA in v-blank
;use a prenmi setup routine
macro dma_fblank_palette(source, to, count)
	sep #$20
	
	stz $2121
	
	ldx.w #<source>
	stx.w $4302
	lda.b #<source>>>16
	sta.b $4304
	
	ldy.w #<count>*2
	sty.w $4305
	
	stz $4300
	lda #$22 
	sta $4301
	
	lda #$01
	sta $420B
	
	rep #$20
endmacro

macro dma_fblank_mode_7(tilemap, graphics)
	stz $2114	;This is for mode 7, so who cares about layer 4
	stz $2116	; vram addr $0000
	lda #$1800
	sta $4300
	
	lda.w #<tilemap>
	sta.w $4302
	lda.w #<tilemap>>>16
	sta.w $4304
	
	ldy #$4000
	sty $4305
	
	lda #$0001	; Enable DMA channel 0
	sta $420B
    
	lda #$8000
	sta $2114	;as above
	stz $2116
	ldx #$1900	; Write to $2119
	stx $4300
	
	ldx.w #<graphics>
	stx.w $4302
	lda.w #$8000|<graphics>>>16
	sta.w $4304
	
	ldy #$1f80	; # of bytes
	sty $4305
	
	lda #$0001
	sta $420B
endmacro
