NMI_wrapper:
	sei
	jml +
	+

	rep #$30
	pha
	phx
	phy
	phd
	lda #$0000
	tcd
	
	lda $4212

	lda frame_ready
	bne +		;If we are lagging, don't bother running NMI
		%jsr_indirect(nmi_mode)
+
	rep #$30
	inc frame_ready
	pld
	ply
	plx
	pla
	cli
	rti

nmi_mode_7:
	sep #$20
	lda brightness
	sta $2100
	
	jsr scale_and_rotate
	
	%write_twice(mode_7_A, $211B)
	%write_twice(mode_7_B, $211C)
	%write_twice(mode_7_C, $211D)
	%write_twice(mode_7_D, $211E)
	
	%write_twice(layer_1_x, $210D)
	%write_twice(layer_1_y, $210E)

	rep #$20
	jmp general_nmi_dma

general_nmi_dma:
	lda dma_hdma_mirror
	sta $420B

	lda oam_priority_settings
	sta $2102

	stz dma_hdma_mirror
nmi_return:
	rts
	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Below are nmi mode implementation routines
; Above should be mostly simple and glue logic of the below
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

scale_and_rotate:
	;only load the low byte
	lda mode_7_rotate
	tax

	lda mode_7_scale_x
	sta $211B
	lda mode_7_scale_x+1
	sta $211B
	lda sincos,x   ;-sin(theta)
	eor #$FF
	inc
	sta $211C
	ldy $2135
	sty mode_7_B

	lda mode_7_scale_y
	sta $211B
	lda mode_7_scale_y+1
	sta $211B
	lda sincos,x
	sta $211C
	ldy $2135
	sty mode_7_C

	; to cos
	txa
	clc
	adc #$40
	tax

	lda mode_7_scale_x
	sta $211B
	lda mode_7_scale_x+1
	sta $211B
	lda sincos,x
	sta $211C
	ldy $2135
	sty mode_7_A

	lda mode_7_scale_y
	sta $211B
	lda mode_7_scale_y+1
	sta $211B
	ldy $2135
	sty mode_7_D
	
	rts
